
const ticatecUtils = new function () {
    /**
     * 判断参数是不是一个函数
     * @param fun
     * @returns {boolean}
     */
    let isFunction = (fun) => {
        return fun instanceof Function;
    }

    /**
     * 调用函数
     * @param fun
     * @param params
     */
    let invokeFunction = (fun, ...params) => {
        if (isFunction(fun)) {
            fun(...params);
        }
    }

    /**
     * 判断字符串是不是空
     * @param s
     * @returns {boolean}
     */
    let isEmpty = (s) => {
        return s == null || s === "" || s.length === 0;
    }

    /**
     * 解析url中的queryString
     * @type {function(*): {}}
     */
    let parseQueryString = (function(d,x,params,p,i,j) {
        return function (qs) {
            params = {};
            let end = qs.indexOf('#');
            if (end === -1) {
                end = qs.length;
            }
            qs = qs.substring(qs.indexOf('?')+1, end).replace(x,' ').split('&');
            for (i = qs.length; i > 0;) {
                p = qs[--i];
                j = p.indexOf('=');
                if(j === -1) params[d(p)] = undefined;
                else params[d(p.substring(0,j))] = d(p.substring(j+1));
            }
            return params;
        };
    })(decodeURIComponent, /\+/g);

    this.isFunction = isFunction;
    this.invokeFunction = invokeFunction;
    this.isEmpty = isEmpty;
    this.parseQueryString = parseQueryString;
}();

export default ticatecUtils;